<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE troubleshooting PUBLIC "-//OASIS//DTD DITA 1.3 Troubleshooting//EN" "troubleshooting.dtd">
<troubleshooting id="wa-browser-out-of-memory">
    <title>Browser Runs Out of Memory when Editing Large Files</title>
  <prolog>
    <metadata>
      <keywords>
        <indexterm>Out of memory</indexterm>
        <indexterm>Common problems<indexterm>Out of memory</indexterm></indexterm>
        <indexterm>Known issues<indexterm>Out of memory</indexterm></indexterm>
      </keywords>
    </metadata>
  </prolog>
  <troublebody>
    <condition id="problem">
      <title>Problem</title>
      <p id="p_vrr_dgk_54b">My browser runs out of memory when working with large documents in <ph
          keyref="webappProduct"/>.</p>
    </condition>
    <troubleSolution>
      <cause id="cause">
        <title>Cause</title>
        <p id="p_wrr_dgk_54b">When <ph keyref="webappProduct"/> renders documents, it causes the browser to consume
          more memory than the original document size.</p>
      </cause>
      <remedy id="solution">
        <title>Solution</title>
        <steps-informal>
          <p id="p_xrr_dgk_54b">To work with large documents, an administrator can configure some of the elements to be
            fold-able. In this case, <ph keyref="webappProduct"/> automatically folds the elements
            in large documents to improve loading times. After the document is loaded, elements are
            progressively unfolded.</p>
          <p id="p_yrr_dgk_54b">To do this, you need to create a custom CSS file that specifies the
            folding:<codeblock  id="codeblock_zrr_dgk_54b">section{
    -oxy-foldable:true;
    -oxy-not-foldable-child: title;
}</codeblock></p>
          <note id="note_asr_dgk_54b">The <codeph>-oxy-foldable</codeph> property does not work with elements that have:
              <codeph>display: inline</codeph>.</note>
          <p id="p_bsr_dgk_54b">To further improve performance, you can set some elements to be folded by default. This
            means the elements need to be manually unfolded by the
            user:<codeblock  id="codeblock_csr_dgk_54b">section{
    -oxy-folded: true;
}</codeblock></p>
          <p id="p_dsr_dgk_54b">To test it, <xref
              href="https://www.oxygenxml.com/doc/ug-waCustom/topics/customizing_frameworks.html"
              format="html" scope="external">configure a custom framework</xref> that associates the
            CSS file to large XML documents.</p>
        </steps-informal>
      </remedy>
    </troubleSolution>
  </troublebody>
</troubleshooting>
